
var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();
messenger.QueryInterface(Components.interfaces.nsIMessenger);

function createTokenizer(){
	var atokenizer=Components.classes['@uniroma3.it/MailClassifier/nsMCTokenizer;1'].createInstance();
	atokenizer.QueryInterface(Components.interfaces.nsIMCTokenizer);
	//atokenizer=getProxyFor(atokenizer,Components.interfaces.nsIMCTokenizer,proxyObjectManager.INVOKE_SYNC | proxyObjectManager.FORCE_PROXY_CREATION);
	return atokenizer;
}

function TokenStreamListener(uri,listener){
	this.uri=uri;
	this.listener=listener;
	this.mTokenizer=createTokenizer();
	this.buffer="";
	this.mSetAttachmentFlag=false;
	this.mLeftOverCount=0;
	this.processHeaders=function(names,values,dontCollectAddress){
 		this.mTokenizer.tokenizeHeaders(names, values);
	}
	this.handleAttachment=function(contentType, url, displayName, uri, aIsExternalAttachment){
   		this.mTokenizer.tokenizeAttachment(contentType, displayName);
	}
	this.getScriptableStream=function(is){
		var sis=Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		//sis=getProxyFor(sis,Components.interfaces.nsIScriptableInputStream,proxyObjectManager.INVOKE_SYNC | proxyObjectManager.FORCE_PROXY_CREATION);
		sis.init(is);
		return sis;
	}
	this.onEndMsgHeaders=function(){}
	this.onEndAllAttachments=function(){}
	this.onDataAvailable=function(request , context , inputStream , offset , count ){
		var sis=this.getScriptableStream(inputStream);
		while(sis.available()>0){
			var car=sis.read(100);
			this.buffer+=car;
		}
		this.mTokenizer.tokenize(this.buffer);
		this.buffer="";
		
	}
	this.onStartRequest=function(request,context){
		request.QueryInterface(Components.interfaces.nsIChannel);
		var uri=request.URI;
		uri.QueryInterface(Components.interfaces.nsIMsgMailNewsUrl);
		uri.msgHeaderSink=this;
	}
	this.onStopRequest=function(request,context,statusCode){
		if(this.listener) this.listener.onTokenAvailable(this.uri,this.mTokenizer);
	}	
    	this.QueryInterface= function (iid) {
        	if(iid.equals(Components.interfaces.nsIStreamListener)) return this;
		if(iid.equals(Components.interfaces.nsIMsgHeaderSink)) return this;
		if(iid.equals(Components.interfaces.nsISupports)) return this;
		
	        throw Components.results.NS_ERROR_NO_INTERFACE;
   	}
}

function tokenizeMessage(uri,listener){
	var tokenListener=new TokenStreamListener(uri,listener);
	var msgService=messenger.messageServiceFromURI(uri);
	msgService=getAsyncProxy(msgService,Components.interfaces.nsIMsgMessageService);
	return msgService.streamMessage(uri,tokenListener,null,null,true,"filter")
}
